/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

/* Implementation of most of the xgrab window */

#include "winview.h"
#include "graph.h"
#include "gview.h"
#include "bview.h"
#include "tview.h"
#include <InterViews/shape.h>
#include <InterViews/sensor.h>
#include <InterViews/banner.h>
#include <InterViews/border.h>
#include <InterViews/box.h>
#include <InterViews/button.h>
#include <InterViews/frame.h>
#include <InterViews/glue.h>
#include <InterViews/menu.h>
#include <InterViews/panner.h>
#include <InterViews/scroller.h>
#include <InterViews/tray.h>
#include <InterViews/viewport.h>
#include <string.h>

GrabWindow::GrabWindow (GView* g, TextView* t) 
{
    gview = g;
    bview = new ButtonView();
    tview = t;
    Init();
}

void GrabWindow::Init () 
{
    Insert(tview);
    Insert(new HBorder);
    Insert(bview);
    Insert(new HBorder);
    Insert(gview);
    SetClassName("GrabWindow");
    Propagate(false);
}
